Index: sandbox/workflow/trunk/inc/engine/src/GUI/GUI.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/GUI/GUI.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/GUI/GUI.php	(revision 2372)
@@ -32,10 +32,9 @@
    * @access public
    */
-  function GUI(&$db) 
+  function GUI()
   {
     $this->child_name = 'GUI';
-    parent::Base($db);
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'common'.SEP.'WfSecurity.php');
-    $this->wf_security =& new WfSecurity($this->db); 
+    parent::Base();
+    $this->wf_security = &Factory::getInstance('WfSecurity');
   }
 
@@ -703,6 +702,5 @@
       if (!(isset($this->pm)))
       {
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'ProcessManager'.SEP.'ProcessManager.php');
-        $this->pm =& new ProcessManager($this->db);
+        $this->pm = &Factory::newInstance('ProcessManager');
       }
       $this->process_cache[$pId]['view'] = $this->pm->get_process_view_activity($pId);
@@ -871,5 +869,5 @@
     {
       //the security object said everything was fine
-      $instance = new Instance($this->db);
+      $instance = &Factory::newInstance('Instance');
       $instance->getInstance($instanceId);
       if (!empty($instance->instanceId)) 
@@ -975,5 +973,5 @@
     {
       //the security object said everything was fine
-      $instance =& new Instance($this->db);
+      $instance = &Factory::newInstance('Instance');
       $instance->getInstance($instanceId);
       // we force the execution of the activity
@@ -1012,5 +1010,5 @@
     {
       //the security object said everything was fine
-      $instance =& new Instance($this->db);
+      $instance = &Factory::newInstance('Instance');
       $instance->getInstance($instanceId);
       // we force the continuation of the flow
Index: sandbox/workflow/trunk/inc/engine/src/ProcessMonitor/ProcessMonitor.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessMonitor/ProcessMonitor.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessMonitor/ProcessMonitor.php	(revision 2372)
@@ -18,8 +18,8 @@
    * @access public
    */
-  function ProcessMonitor(&$db)
+  function ProcessMonitor()
   {
     $this->child_name = 'ProcessMonitor';
-    parent::Base($db);
+    parent::Base();
     // check the the actual user can really do this
     if ( !(galaxia_user_can_monitor()))
Index: sandbox/workflow/trunk/inc/engine/src/common/Base.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/common/Base.php	(revision 2165)
+++ sandbox/workflow/trunk/inc/engine/src/common/Base.php	(revision 2372)
@@ -39,4 +39,12 @@
   	var $child_name = 'Base';
 
+	/**
+	 * @var object $db_shared_obj The database abstraction object shared between
+	 *						      all instances of this class.
+	 * @acess private
+	 * @static
+	 */
+	private static $db_shared_obj = null;
+
   /**
    * Constructor receiving a database abstraction object
@@ -46,14 +54,34 @@
    * @access public
    */
-  function Base(&$db)
+  function Base()
   {
-    if(!$db) {
+  	/**
+	 * New Stuff!
+	 * We decided to get here the database object. In a recent past,
+	 * all the classes that specialize this one passed a db object.
+	 * Now, to simplify and save memory, we store the database object
+	 * into a single and static atribute shared among each instance
+	 * of this class.
+	 *
+	 * To prevent to modify all sub-classes to use "self::$db" instead
+	 * of "this->db", we made a very tiny workaround here. In the first
+	 * instantiation of this class, we instantiate the database object
+	 * and store it into 'self::$db_shared_obj'. Any subsequent
+	 * instantiations will just point to the static one.
+	 */
+	if (!self::$db_shared_obj)
+		self::$db_shared_obj = &Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
+
+	$this->db = &self::$db_shared_obj;
+
+
+    if(!$this->db) {
       die('Invalid db object passed to '.$this->child_name.' constructor');
     }
     //Force transactionnal mysql (Innodb) -> mysqlt
-    if ($db->databaseType=='mysql')
+    if ($this->db->databaseType=='mysql')
     {
     	$GLOBALS['phpgw']->db->disconnect();
-    	$db = $GLOBALS['phpgw']->db->connect(
+    	$this->db = $GLOBALS['phpgw']->db->connect(
 			$GLOBALS['phpgw_info']['server']['db_name'],
 			$GLOBALS['phpgw_info']['server']['db_host'],
@@ -64,5 +92,4 @@
 		);
     }
-    $this->db = &$db;
   }
 
Index: sandbox/workflow/trunk/inc/engine/src/common/WfRuntime.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/common/WfRuntime.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/common/WfRuntime.php	(revision 2372)
@@ -86,18 +86,14 @@
    * @access public
    */
-  function WfRuntime(&$db) 
+  function WfRuntime() 
   {
     $this->child_name = 'WfRuntime';
-    parent::Base($db);
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'BaseActivity.php');
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'Process.php');
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'Instance.php');
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'common'.SEP.'WfSecurity.php');
-    
+    parent::Base();
+
     //first the activity is not set
     $this->activity = null;
-    $this->instance = new Instance($this->db);
-    $this->process = new Process($this->db);
-    $this->security = new WfSecurity($this->db); 
+    $this->instance = &Factory::newInstance('Instance');
+    $this->process = &Factory::newInstance('Process');
+    $this->security = &Factory::getInstance('WfSecurity');
   }
 
@@ -276,5 +272,5 @@
       return false;
     }
-    $base_activity = new BaseActivity($this->db);
+    $base_activity = &Factory::newInstance('BaseActivity');
     $this->activity =& $base_activity->getActivity($activity_id, $with_roles, $with_agents);
     if (!$this->activity)
@@ -1091,5 +1087,5 @@
     $workflow = $GLOBALS['workflow'];
     unset($_REQUEST['iid']);
-    $run_activity = CreateObject('workflow.run_activity');
+    $run_activity = Factory::getInstance('run_activity');
     $run_activity->runtime->instance->parentInstanceId = $this->instance_id;
     $run_activity->runtime->instance->parentActivityId = $this->activity_id;
Index: sandbox/workflow/trunk/inc/engine/src/common/WfSecurity.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/common/WfSecurity.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/common/WfSecurity.php	(revision 2372)
@@ -23,11 +23,8 @@
    * @access public
    */
-  function WfSecurity(&$db) 
+  function WfSecurity() 
   {
     $this->child_name = 'WfSecurity';
-    parent::Base($db);
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'Instance.php');
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'Process.php');
-    require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'BaseActivity.php');
+    parent::Base();
   }
 
@@ -58,5 +55,5 @@
       );
       //check theses values for this process and store the result for this object life duration
-      $myProcess = new Process($this->db);
+      $myProcess = &Factory::newInstance('Process');
       $myProcess->getProcess($pId);
       $this->processesConfig[$pId] = $myProcess->getConfigValues($arrayConf);
@@ -78,4 +75,9 @@
   function checkUserAccess($user, $activity_id, $readonly=false) 
   {
+	/* if activity is non-interactive is not necessary checking user access */
+	$activity = &Factory::getInstance('BaseActivity')->getActivity($activity_id);
+	if (!$activity->isInteractive())
+		return true;
+
     //group mapping, warning groups and user can have the same id
     if ($user[0] != 'p')
@@ -577,6 +579,5 @@
       if (!(isset($this->pm)))
       {
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'ProcessManager'.SEP.'ProcessManager.php');
-        $this->pm = new ProcessManager($this->db);
+        $this->pm = &Factory::newInstance('ProcessManager');
       }
       //$this->error[] = 'DEBUG: checking to see if there is no view activities on process :'.$pId.':'.$this->pm->get_process_view_activity($pId);
Index: sandbox/workflow/trunk/inc/engine/src/API/Process.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/Process.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/Process.php	(revision 2372)
@@ -48,8 +48,8 @@
 	 * @access public
 	 */
-	function Process(&$db) 
+	function Process() 
 	{
 		$this->child_name = 'Process';
-		parent::Base($db);
+		parent::Base();
 	}
 
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/View.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/View.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/View.php	(revision 2372)
@@ -16,7 +16,7 @@
 	 * @access public
 	 */	
-	function View(&$db)
+	function View()
 	{
-	 	parent::Base($db);
+	 	parent::Base();
 		$this->child_name = 'View';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/Split.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/Split.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/Split.php	(revision 2372)
@@ -15,7 +15,7 @@
 	 * @access public
 	 */
-	function Split(&$db)
+	function Split()
 	{
-	 	parent::Base($db);
+	 	parent::Base();
 		$this->child_name = 'Split';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/Activity.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/Activity.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/Activity.php	(revision 2372)
@@ -16,7 +16,7 @@
 	 * @access public
 	 */
-	function Activity(&$db)
+	function Activity()
 	{
-		parent::Base($db);
+		parent::Base();
 		$this->child_name = 'Activity';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/Start.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/Start.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/Start.php	(revision 2372)
@@ -15,7 +15,7 @@
 	 * @access public
 	 */
-	function Start(&$db)
+	function Start()
 	{
-	 	parent::Base($db);
+	 	parent::Base();
 		$this->child_name = 'Start';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/SwitchActivity.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/SwitchActivity.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/SwitchActivity.php	(revision 2372)
@@ -16,7 +16,7 @@
 	 * @access public
 	 */
-	function SwitchActivity(&$db)
+	function SwitchActivity()
 	{
-	   parent::Base($db);
+	   parent::Base();
 	   $this->child_name = 'Switch';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/Join.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/Join.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/Join.php	(revision 2372)
@@ -15,7 +15,7 @@
 	 * @access public
 	 */
-	function Join(&$db)
+	function Join()
 	{
-	 	parent::Base($db);
+	 	parent::Base();
 		$this->child_name = 'Join';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/End.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/End.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/End.php	(revision 2372)
@@ -15,7 +15,7 @@
 	 * @access public
 	 */
-	function End(&$db)
+	function End()
 	{
-	 	parent::Base($db);
+	 	parent::Base();
 		$this->child_name = 'End';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/activities/Standalone.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/activities/Standalone.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/activities/Standalone.php	(revision 2372)
@@ -15,7 +15,7 @@
 	 * @access public
 	 */
-	function Standalone(&$db)
+	function Standalone()
 	{
-	 	parent::Base($db);
+	 	parent::Base();
 		$this->child_name = 'Standalone';
 	}
Index: sandbox/workflow/trunk/inc/engine/src/API/Instance.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/Instance.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/Instance.php	(revision 2372)
@@ -1,5 +1,4 @@
 <?php
 require_once (GALAXIA_LIBRARY.SEP.'src'.SEP.'common'.SEP.'Base.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'common' . SEP . 'WfSecurity.php');
 require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
 
@@ -141,8 +140,8 @@
 
   var $activityID = null;
-  function Instance($db) 
+  function Instance() 
   {
     $this->child_name = 'Instance';
-    parent::Base($db);
+    parent::Base();
   }
 
@@ -1171,5 +1170,5 @@
     
     //lock rows and ensure access is granted
-    if (!(isset($this->security))) $this->security =& new WfSecurity($this->db); 
+    if (!(isset($this->security))) $this->security = &Factory::getInstance('WfSecurity', $this->db);
     if (!($this->security->checkUserAction($activityId,$this->instanceId,'complete')))
     {
@@ -1551,5 +1550,5 @@
     {
       //we check rights for this user on the next activity
-      if (!(isset($this->security))) $this->security =& new WfSecurity($this->db); 
+      if (!(isset($this->security))) $this->security = &Factory::getInstance('WfSecurity');
       if ($this->security->checkUserAccess($the_next_user,$activityId))
       {
@@ -1560,5 +1559,5 @@
     {
       // then check to see if there is a default user
-      $activity_manager =& new ActivityManager($this->db);
+      $activity_manager = &Factory::newInstance('ActivityManager');
       //get_default_user will give us '*' if there is no default_user or if the default user has no role
       //mapped anymore
Index: sandbox/workflow/trunk/inc/engine/src/API/BaseActivity.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/API/BaseActivity.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/API/BaseActivity.php	(revision 2372)
@@ -97,9 +97,9 @@
    * @access public
    */
-  function BaseActivity(&$db)
+  function BaseActivity()
   {
     $this->type='base';
     $this->child_name = 'BaseActivity';
-    parent::Base($db);
+    parent::Base();
   }
 
@@ -122,41 +122,42 @@
     if(!$result || !$result->numRows() ) return false;
     $res = $result->fetchRow();
+
     switch($res['wf_type']) {
       case 'start':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'Start.php');
-        $act = new Start($this->db);  
-        break;
+        $act = &Factory::newInstance('Start');
+        break;
+
       case 'end':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'End.php');
-        $act = new End($this->db);
-        break;
+        $act = &Factory::newInstance('End');
+        break;
+
       case 'join':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'Join.php');
-        $act = new Join($this->db);
-        break;
+        $act = &Factory::newInstance('Join');
+        break;
+
       case 'split':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'Split.php');
-        $act = new Split($this->db);
-        break;
+        $act = &Factory::newInstance('Split');
+        break;
+
       case 'standalone':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'Standalone.php');
-        $act = new Standalone($this->db);
-        break;
+        $act = &Factory::newInstance('Standalone');
+        break;
+
       case 'view':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'View.php');
-        $act = new View($this->db);
-        break;
+        $act = &Factory::newInstance('View');
+        break;
+
       case 'switch':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'SwitchActivity.php');
-        $act = new SwitchActivity($this->db);
-        break;
+        $act = &Factory::newInstance('SwitchActivity');
+        break;
+
       case 'activity':
-        require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP.'activities'.SEP.'Activity.php');
-        $act = new Activity($this->db);
-        break;
+        $act = &Factory::newInstance('Activity');
+        break;
+
       default:
         trigger_error('Unknown activity type:'.$res['wf_type'],E_USER_WARNING);
     }
-    
+
     $act->setName($res['wf_name']);
     $act->setProcessId($res['wf_p_id']);
Index: sandbox/workflow/trunk/inc/engine/src/ProcessManager/ProcessManager.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessManager/ProcessManager.php	(revision 2165)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessManager/ProcessManager.php	(revision 2372)
@@ -66,10 +66,8 @@
 	 * @access public
 	 */
-	function ProcessManager(&$db)
-	{
-		parent::BaseManager($db);
+	function ProcessManager()
+	{
+		parent::BaseManager();
 		$this->child_name = 'ProcessManager';
-		require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'ProcessManager'.SEP.'ActivityManager.php');
-		require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'ProcessManager'.SEP.'JobManager.php');
 		// $this->activity_manager is not set here to avoid objects loading object A loading object B loading object A, etc
 		//$this->role_manager will only be loaded when needed as well
@@ -131,5 +129,5 @@
 	function serialize_process($pId)
 	{
-		if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
+		if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
 		// <process>
 		$out = '<process>'."\n";
@@ -459,8 +457,8 @@
 	{
 		//Now the show begins
-		if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
-		if (!(isset($this->role_manager))) $this->role_manager = new RoleManager($this->db);
+		if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
+		if (!(isset($this->role_manager))) $this->role_manager = &Factory::newInstance('RoleManager');
 		if (!isset($this->jobManager))
-			$this->jobManager = new JobManager($this->db);
+			$this->jobManager = &Factory::newInstance('JobManager');
 
 		// First create the process. Always inactive and inactive first.
@@ -620,5 +618,5 @@
 	function new_process_version($pId, $minor=true)
 	{
-		if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
+		if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
 		$oldpid = $pId;
 		//retrieve process info with config rows
@@ -671,5 +669,5 @@
 		}
 		// create roles
-		if (!(isset($this->role_manager))) $this->role_manager = new RoleManager($this->db);
+		if (!(isset($this->role_manager))) $this->role_manager = &Factory::newInstance('RoleManager');
 		$query = 'select * from '.GALAXIA_TABLE_PREFIX.'roles where wf_p_id=?';
 		$result = $this->query($query, array($oldpid));
@@ -853,7 +851,7 @@
 	function remove_process($pId)
 	{
-		if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
+		if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
 		if (!isset($this->jobManager))
-			$this->jobManager = new JobManager($this->db);
+			$this->jobManager = &Factory::newInstance('JobManager');
 		$this->deactivate_process($pId);
 		$name = $this->_get_normalized_name($pId);
@@ -919,5 +917,5 @@
 	function replace_process($pId, &$vars, $create = true)
 	{
-		if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
+		if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
 		$TABLE_NAME = GALAXIA_TABLE_PREFIX.'processes';
 		$now = date("U");
@@ -1296,5 +1294,5 @@
 		{
 			//Warning: this means you have to include the Process.php from the API
-			$this->Process = new Process($this->db);
+			$this->Process = &Factory::newInstance('Process');
 			$this->Process->getProcess($pId);
 			$result_array = $this->Process->getConfigValues($config_array);
@@ -1316,5 +1314,5 @@
 	{
 		//Warning: this means you have to include the Process.php from the API
-		$this->Process = new Process($this->db);
+		$this->Process = &Factory::newInstance('Process');
 		$this->Process->getProcess($pId);
 		$this->Process->setConfigValues($config_array);
Index: sandbox/workflow/trunk/inc/engine/src/ProcessManager/RoleManager.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessManager/RoleManager.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessManager/RoleManager.php	(revision 2372)
@@ -19,7 +19,7 @@
    * @access public
    */
-  function RoleManager(&$db) 
-  {
-    parent::Base($db);
+  function RoleManager() 
+  {
+    parent::Base();
     $this->child_name = 'RoleManager';
   }
@@ -247,5 +247,5 @@
     $result = $this->query($query,$bindvars);
     $ret = Array();
-    $ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+    $ldap = &Factory::getInstance('WorkflowLDAP');
     if (!(empty($result)))
     {
@@ -256,8 +256,10 @@
           //we have a group instead of a simple user and we want real users
           $real_users = galaxia_retrieve_group_users($res['wf_user'], true);
-          foreach ($real_users as $key => $value)
-          {
-            $ret[$key]=$value;
-          }
+		  if (!empty($real_users)) {
+            foreach ($real_users as $key => $value)
+            {
+              $ret[$key]=$value;
+            }
+		  }
         }
         else
Index: sandbox/workflow/trunk/inc/engine/src/ProcessManager/InstanceManager.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessManager/InstanceManager.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessManager/InstanceManager.php	(revision 2372)
@@ -16,7 +16,7 @@
    * @access public
    */
-  function InstanceManager(&$db) 
-  {
-    parent::BaseManager($db);
+  function InstanceManager() 
+  {
+    parent::BaseManager();
     $this->child_name = 'InstanceManager';
   }
Index: sandbox/workflow/trunk/inc/engine/src/ProcessManager/BaseManager.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessManager/BaseManager.php	(revision 2165)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessManager/BaseManager.php	(revision 2372)
@@ -18,8 +18,8 @@
    * @access public
    */
-  function BaseManager(&$db)
+  function BaseManager()
   {
     $this->child_name = 'BaseManager';
-    parent::Base($db);
+    parent::Base();
   }
 
Index: sandbox/workflow/trunk/inc/engine/src/ProcessManager/JobManager.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessManager/JobManager.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessManager/JobManager.php	(revision 2372)
@@ -76,12 +76,12 @@
 	 * @access public
 	 */
-	public function JobManager(&$db)
-	{
-		parent::BaseManager($db);
+	public function JobManager()
+	{
+		parent::BaseManager();
 		$this->child_name = 'JobManager';
 
 		$this->jobTable = GALAXIA_TABLE_PREFIX . 'jobs';
 		$this->logTable = GALAXIA_TABLE_PREFIX . 'job_logs';
-		$this->processManager = new ProcessManager($this->db);
+		$this->processManager = &Factory::newInstance('ProcessManager');
 	}
 
Index: sandbox/workflow/trunk/inc/engine/src/ProcessManager/ActivityManager.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/src/ProcessManager/ActivityManager.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/src/ProcessManager/ActivityManager.php	(revision 2372)
@@ -26,7 +26,7 @@
    * @access public
    */
-  function ActivityManager(&$db)
-  {
-    parent::BaseManager($db);
+  function ActivityManager()
+  {
+    parent::BaseManager();
     $this->child_name = 'ActivityManager';
     require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'ProcessManager' .SEP . 'ProcessManager.php');
@@ -370,9 +370,9 @@
   function build_process_graph($pId)
   {
-    if (!(isset($this->process_manager))) $this->process_manager = new ProcessManager($this->db);
+    if (!(isset($this->process_manager))) $this->process_manager = &Factory::newInstance('ProcessManager');
     $attributes = Array(
     
     );
-    $graph = new Process_GraphViz(true,$attributes);
+    $graph = &Factory::newInstance('Process_GraphViz', true, $attributes);
     $name = $this->process_manager->_get_normalized_name($pId);
     $graph->set_pid($name);
@@ -747,5 +747,5 @@
   {
     require_once(GALAXIA_LIBRARY.SEP.'src'.SEP.'API'.SEP . 'BaseActivity.php');
-    $act = new BaseActivity($this->db);
+    $act = &Factory::newInstance('BaseActivity');
     //Warning, we now use the BaseActivity object for it, interactivity and autorouting is now true/fales, not y/n
     return ($act->getActivity($activityId,false,true, true));
@@ -825,5 +825,5 @@
   function remove_activity($pId, $activityId, $transaction = true)
   {
-    if (!(isset($this->process_manager))) $this->process_manager = new ProcessManager($this->db);
+    if (!(isset($this->process_manager))) $this->process_manager = &Factory::newInstance('ProcessManager');
     $proc_info = $this->process_manager->get_process($pId);
     $actname = $this->_get_normalized_name($activityId);
@@ -888,5 +888,5 @@
   function replace_activity($pId, $activityId, $vars, $create_files=true)
   {
-    if (!(isset($this->process_manager))) $this->process_manager = new ProcessManager($this->db);
+    if (!(isset($this->process_manager))) $this->process_manager = &Factory::newInstance('ProcessManager');
     $TABLE_NAME = GALAXIA_TABLE_PREFIX.'activities';
     $now = date("U");
@@ -1195,5 +1195,5 @@
     elseif ( (!($result=='*')) && $performAccessCheck)
     {
-      $wf_security = new WfSecurity($this->db);
+      $wf_security = &Factory::getInstance('WfSecurity', $this->db);
       // perform the check
       if (!($wf_security->checkUserAccess($result,$activityId)))
Index: sandbox/workflow/trunk/inc/engine/class.ajax_config.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/class.ajax_config.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/class.ajax_config.inc.php	(revision 2372)
@@ -45,5 +45,5 @@
 		}
 
-		$this->db      = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+		$this->db      =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
 		$this->appname = $appname;
   	}
@@ -51,5 +51,5 @@
  	/**
    	* Reads the whole repository for $this->appname, appname has to be set via the constructor
-   	* 
+   	*
    	* @return array the whole config-array for that app
    	* @access public
Index: sandbox/workflow/trunk/inc/hook_home.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/hook_home.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/hook_home.inc.php	(revision 2372)
@@ -1,3 +1,5 @@
 <?php
+require_once 'common.inc.php';
+
 $GLOBALS['phpgw_info']['flags']['currentapp'] = "workflow";
 if (!isset($_SESSION['phpgw_info']['workflow']['server']))
@@ -22,5 +24,5 @@
 
 $title = lang("External Applications");
-$bo	= CreateObject('workflow.bo_userinterface');
+$bo	= Factory::getInstance('bo_userinterface');
 $externals 	= $bo -> externals();
 $extra_data = '';
@@ -42,5 +44,5 @@
 }
 $extra_data .= "</table></div>";
-$portalbox = CreateObject('phpgwapi.listbox',
+$portalbox = Factory::getInstance('listbox',
 	Array(
 		'title'     => $title,
Index: sandbox/workflow/trunk/inc/class.workflow_process.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_process.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_process.inc.php	(revision 2372)
@@ -16,5 +16,5 @@
 		function workflow_process()
 		{
-			parent::Process($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::Process(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.JobScheduler.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.JobScheduler.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.JobScheduler.inc.php	(revision 2372)
@@ -11,7 +11,4 @@
 
 require_once 'jobs/class.JobEnum.inc.php';
-require_once 'jobs/class.AbsoluteDate.inc.php';
-require_once 'jobs/class.WeekDate.inc.php';
-require_once 'jobs/class.RelativeDate.inc.php';
 
 /**
@@ -57,6 +54,6 @@
 	{
 		$this->currentDate = new DateTime(date('Y-n-j G:i:00'));
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
-		$this->jobManager = &$GLOBALS['workflow']['factory']->getInstance('WorkflowJobManager');
+		$this->db = &Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
+		$this->jobManager = &Factory::getInstance('WorkflowJobManager');
 	}
 
@@ -76,14 +73,14 @@
 		{
 			case DateType::ABSOLUTE_DATE:
-				$object = new AbsoluteDate($startDate, $interval);
+				$object = &Factory::getInstance('AbsoluteDate', $startDate, $interval);
 				break;
 
 			case DateType::WEEK_DATE:
-				$object = new WeekDate($startDate, $interval);
+				$object = &Factory::getInstance('WeekDate', $startDate, $interval);
 				$object->setWeekDays($record['week_days']);
 				break;
 
 			case DateType::RELATIVE_DATE:
-				$object = new RelativeDate($startDate, $interval);
+				$object = &Factory::getInstance('RelativeDate', $startDate, $interval);
 				$object->setOffset($record['month_offset']);
 				break;
@@ -171,5 +168,5 @@
 		$previousDir = getcwd();
 		chdir(GALAXIA_LIBRARY . '/../');
-		$output = $GLOBALS['workflow']['factory']->newInstance('Thread', 'class.JobRunner.inc.php "' . $parameters . '"');
+		$output = Factory::newInstance('Thread', 'class.JobRunner.inc.php "' . $parameters . '"');
 		chdir($previousDir);
 		return $output;
@@ -192,7 +189,7 @@
 {
 	require_once 'common.inc.php';
-	$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+	Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 
-	$job = new JobScheduler();
+	$job = Factory::newInstance('JobScheduler');
 	$job->run();
 }
